/*
	T/SDAS-SCOM2 demo utility.
	demo functions: Dual-channel Analog I/O.
*/

struct	MCD_DD
	{ int	m_id,
		prg_id,
                status,
                err,
		cmnd;
	  int	fq;
	  int   epoch_len,
                adc_data_ptr,
                dac_data_ptr,
		chan ,

		is,
		ra,
		rb,
		in_gain,
		out_gain

                ;
	} ;

struct	MCD_DD *MCD	= (struct MCD_DD *)0x40;



#define	T31_ID			0x101
#define	PRG_ID			0x100

#define	MSTAT_RDY		0 /* Master status values */
#define	MSTAT_BUSY		1
#define	MSTAT_ATTN		2
#define	MSTAT_GO		3
#define	MSTAT_ABORT		4

#define	MERR_OK			0 /* Master returned error codes */
#define	MERR_INV_CMND		1 /*     ; invalid command */
#define	MERR_INV_ATTN		2

#define	MCMND_NOP		0
#define	MCMND_ABORT		1

#define	MCMND_DAS_SCAN		0x100
#define	MCMND_DAS_DAC_SCAN	0x101
#define	MCMND_DAC_SING_LOAD	0x102
#define	MCMND_ADC_TO_DAC	0x103

#define	ML_OFF			0
#define	ML_ON			1

#define	MDATA_BUF_LEN		0x3c00L /* maximum data array length */


extern  int adc_data_start;
extern	int dac_data_start;
int	*ADC,	*DAC;		/* ptrs to the ADC/DAC data */

int	host_rq_flag=0;


#include	<math.h>
#include 	"c3x_def.h"
#include 	"t3x_dsp.h"
#include	"d3_c2_a2.i"

void c_int30()
  { host_rq_flag=1;
  }

cpu_init()
 {
	   *C3X_PBUS_GC = 0xf0600;
	   *C3X_XBUS_GC = 0xf0600;

        C3X_INT_EDGE;
		C3X_CACHE_ENABLE;
 }





int	cmnd_decoder()			/* command decoder	*/
 {
	if(MCD->status!=MSTAT_ATTN) return(MERR_INV_ATTN);

	MCD->status=MSTAT_BUSY;

	switch(MCD->cmnd)
	 {
	   case MCMND_NOP:		/* common cmnds */
	   case MCMND_ABORT:
		 return(MERR_OK);

                                        /* application specific commands */
	   case MCMND_DAS_DAC_SCAN:
	   	 return( adc_dac_scan() );

	   case MCMND_ADC_TO_DAC:
	   	 return( adc_dac_scan() );

	   default:			/* all unknown commands cause error */
		 return( MERR_INV_CMND );
	 }

 }



void main()
{
	cpu_init();

	ADC	=   (int *) &adc_data_start ;
	DAC	=   (int *) &dac_data_start ;

	adc_data_start_ptr	= (int) ADC;
        adc_save_ptr		= (int) ADC;
	dac_data_start_ptr	= (int) DAC;
	dac_get_ptr		= (int) DAC;

	MCD->m_id		= T31_ID;
	MCD->prg_id		= PRG_ID;
	MCD->cmnd		= 0;
	MCD->fq			= 0;
	MCD->epoch_len		= 0;
	MCD->err		= MERR_OK;
	MCD->adc_data_ptr	= (int) ADC;
	MCD->dac_data_ptr	= (int) DAC;

	MCD->status=MSTAT_BUSY;
	system_init();
 	MCD->status=MSTAT_RDY;

	while(1)			/* continuous loop	*/
	 {
	   host_rq_flag=0;		/* poll for the HOST RQ */

	   C3X_XINT_CLEAR(3);
	   C3X_XINT_ENABLE(3);

           while(host_rq_flag==0) ;

	   C3X_XINT_DISABLE(3);		/* disable HOST RQ	*/

	   MCD->err = cmnd_decoder();	/* call exec & return error code */
           MCD->status = MSTAT_RDY;	/* clear status flag */
	 }
}
