/*
        Application specific execution module.
	device: T/SDAS-SCOM2
	demo functions: Dual-channel Analog I/O
*/


typedef struct
	{ unsigned int data :8; /* Register data    */
	  unsigned int addr :5; /* Register Address */
	  unsigned int r_w  :1; /* Read/!Write mode */
	  unsigned int ctrl :2; /* Control Bits     */
	} AIC_CMND_0;

AIC_CMND_0	aic_cmnd_0,
		aic_cmnd15,
		aic_cmnd1,
		aic_cmnd2,
		aic_cmnd3,
		aic_cmnd4,
		aic_cmnd5,
		aic_cmnd6,
		aic_cmnd7,
		aic_cmnd8;


#define	SIO_GC_DATA_MODE		0x02970300
#define	SIO_XC_DATA_MODE		0x111
#define	SIO_RC_DATA_MODE		0x111
#define	SIO_GC_GO_MASK			0xc000000

#define TM_GC_DATA			0x303
#define TM_PER_DATA			200
#define TM_GC_GO_MASK			0xc0


		/* X/R interrupt handler parameters	*/

int	dac_scan_flag		= ML_OFF,
	dac_cyclic_scan_flag	= ML_ON,
	dac_data_start_ptr,
        dac_get_ptr,
	dac_data_count,
        dac_data_count_max,

	send_master_cmnd	= ML_OFF,
	send_slave_cmnd		= ML_OFF,
	aic_cmnd		= 0xcf00,	/* = aic_cmnd15	*/
	master_cmnd		= 0xc000,
	slave_cmnd		= 0xc000,
	program_aic		= ML_ON
         ;

int	adc_scan_flag		= ML_OFF,
	adc_cyclic_scan_flag	= ML_OFF,
	adc_save_ptr,
	adc_data_start_ptr,
	adc_data_count,
	adc_data_count_max ;


int r_data, din;

void c_int11()   /* TORNADO-3x SIO-port receiver interrupt */
{
	unsigned   r_fs;

	r_data=(*C3X_SIO0_RD) ;
	r_fs = r_data & 0x3 ;

		/*
	   	    master primary     - r_fs=0
		    slave  primary     - r_fs=1
		    master secondary   - r_fs=2
		    slave  secondary   - r_fs=3
		*/

	switch(r_fs)
	    {
		case 0:
		   {
		   	if(adc_scan_flag==ML_ON)
			 {
			   r_data= (r_data )>>2;
                           *((int *)(adc_save_ptr))=r_data;
			 }
		   }
		    break ;
		case 1:

                     if(adc_scan_flag==ML_ON)
			  {
			   r_data= (r_data )>>2;
                           *((int *)(adc_save_ptr+adc_data_count_max))=r_data;
                           adc_save_ptr++;
                           if(++adc_data_count >=adc_data_count_max)
				 { if(adc_cyclic_scan_flag==ML_ON)
				      {
					adc_data_count=0;
                                        adc_save_ptr=adc_data_start_ptr;
				      }
				      else
				        adc_scan_flag=ML_OFF;
				 }

			  }
		    break ;
		case 2:
		    din= ((r_data )>>12) & 0x000f;
		    break ;

		case 3:
		default:    break ;
	    }
}



unsigned   t_fs=0;

int	p_p=0;

void c_int10()   /* TORNADO-3x SIO-port transmitter interrupt */
{
	if (program_aic)
	  {
	     switch(p_p)
		{
		 case  0:
		 case  1:
		 case  2:
		 		*C3X_SIO0_XD=0x0;		        break;
		 case  3:
		 case  5:
		 case  7:
		 case  9:
		 case  11:
		 case  13:
		 case  15:
		 case  17:
		 		*C3X_SIO0_XD=0x3;      break;
		 case  4:
		 	  *C3X_SIO0_XD=*((unsigned *) &aic_cmnd8);	break;
		 case  6:
		 	  *C3X_SIO0_XD=*((unsigned *) &aic_cmnd6);	break;
		 case  8:
		 	  *C3X_SIO0_XD=*((unsigned *) &aic_cmnd1);	break;
		 case 10:
		 	  *C3X_SIO0_XD=*((unsigned *) &aic_cmnd2);	break;
		 case 12:
		 	  *C3X_SIO0_XD=*((unsigned *) &aic_cmnd3);	break;
		 case 14:
		 	  *C3X_SIO0_XD=*((unsigned *) &aic_cmnd4);	break;
		 case 16:
		 	  *C3X_SIO0_XD=*((unsigned *) &aic_cmnd5);	break;
		 case 18:
		 	  *C3X_SIO0_XD=*((unsigned *) &aic_cmnd7);
		 	   p_p=-1;
			   program_aic=ML_OFF;
			   t_fs=0;
			   break;

	   	   default: break;
 		};
		p_p++;
	  }
	 else
	   {    /*
	   	    master primary transmit    - t_fs=0
		    slave  primary transmit    - t_fs=1
		    master secondary transmit  - t_fs=2
		    slave  secondary transmit  - t_fs=3
		*/
	     switch(t_fs)
		{
		  case 0:    if(dac_scan_flag==ML_OFF)
	 			{  		/* if DAC-scan is disabled : */
	   			 *C3X_SIO0_XD=0x3;/* send data=0 and LSB[1,0]=#3 */
         			}
	 			else
	  			  {
	    			   *C3X_SIO0_XD=((*((int*)dac_get_ptr))<<2) | 0x3;
				  }
			     break;

		  case 1:    if(dac_scan_flag==ML_OFF)
	 			{  		/* if DAC-scan is disabled : */
	   			 *C3X_SIO0_XD=0x3;/* send data=0 and LSB[1,0]=#3 */
         			}
	 			else
	  			  {
	    			   *C3X_SIO0_XD=((*((int*)(dac_get_ptr+dac_data_count_max)))<<2) | 0x3;
				     dac_get_ptr++;
				     if(++dac_data_count >=dac_data_count_max)
				       { if(dac_cyclic_scan_flag==ML_ON)
				            {
				          	   dac_data_count=0;
				               dac_get_ptr=dac_data_start_ptr;
				            }
				          else
				            dac_scan_flag=ML_OFF;
				       }
				  }
			     break;

		  case 2:    if(send_master_cmnd)
			      {
			        *C3X_SIO0_XD=master_cmnd;/**((unsigned *) &aic_cmnd15);*/
			      }
			      else
			      {
			      	*C3X_SIO0_XD= (aic_cmnd & 0xff00) | ((din<<4) & 0x00f0);
			      }
			     break;

		  case 3:    if(send_slave_cmnd)
			      {
			        *C3X_SIO0_XD= slave_cmnd ;
			      }
			      else
			      {
			        *C3X_SIO0_XD=0x0;
			      }
			     break;
	   	   default: break;
		}

	     t_fs=(t_fs+1) & 0x3 ;
	   }
}

void set_config_aic()
  {
	dac_scan_flag		= ML_OFF;
	adc_scan_flag		= ML_OFF;
	send_master_cmnd	= ML_OFF;
	send_slave_cmnd		= ML_OFF;

	aic_cmnd	= 0x0fa0;
	slave_cmnd	= 0x0;
	master_cmnd	= 0x0;

		aic_cmnd1.ctrl=0;
		aic_cmnd1.r_w=0;
		aic_cmnd1.addr=1;
		aic_cmnd1.data	= MCD->ra & 0xff;

		aic_cmnd2.ctrl=0;
		aic_cmnd2.r_w=0;
		aic_cmnd2.addr=2;
		aic_cmnd2.data	= MCD->rb & 0xff;

		aic_cmnd3.ctrl=0;
		aic_cmnd3.r_w=0;
		aic_cmnd3.addr=3;
		aic_cmnd3.data =0 ;

		aic_cmnd4.ctrl=0;
		aic_cmnd4.r_w=0;
		aic_cmnd4.addr=4;
		aic_cmnd4.data = ((((MCD->in_gain)+1)<<2)+((MCD->out_gain)+1)) & 0xf ;

		aic_cmnd5.ctrl=0;
		aic_cmnd5.r_w=0;
		aic_cmnd5.addr=5;
		aic_cmnd5.data = ((MCD->is)+1) & 0x3 ;

		aic_cmnd6.ctrl=0;
		aic_cmnd6.r_w=0;
		aic_cmnd6.addr=6;
		aic_cmnd6.data =0x24 ;

		aic_cmnd7.ctrl=0;
		aic_cmnd7.r_w=0;
		aic_cmnd7.addr=7;
		aic_cmnd7.data =18 ;

		aic_cmnd8.ctrl=0;
		aic_cmnd8.r_w=0;
		aic_cmnd8.addr=8;
		aic_cmnd8.data =2 ;

		aic_cmnd15.ctrl=0;
		aic_cmnd15.r_w=0;
		aic_cmnd15.addr=15;
		aic_cmnd15.data = 0x50 ;

	t_fs=0;
	p_p=0;

  }


void init_sio()		/* TORNADO-3x SIO-port initialization */
 {      unsigned rd;
	*C3X_SIO0_GC = SIO_GC_DATA_MODE  ;
	*C3X_SIO0_XC = SIO_XC_DATA_MODE  ;
	*C3X_SIO0_RC = SIO_RC_DATA_MODE  ;
	*C3X_SIO0_GC = SIO_GC_DATA_MODE | SIO_GC_GO_MASK ;


	*C3X_SIO0_XD = 0  ;			/* perform transmission of false
					   word to init transmitter OK */
	rd=*C3X_SIO0_RD;
 }


void system_init()
{

	set_config_aic();
	program_aic=ML_ON;

	init_sio();

	C3X_SR0_INT_CLEAR;
	C3X_SX0_INT_ENABLE;
	C3X_SR0_INT_ENABLE;

	C3X_INT_ENABLE;

	while(program_aic);


}


/****************************************************************************/

	/* this procedure performs cyclic DAC output and waits for
	   host to enable ADC scanning. Then it saves ADC data and terminates.
	*/

int	adc_dac_scan()
  {
				/* set X/R interrupt driver parameters */
	adc_data_start_ptr	= (int) ADC;
        adc_save_ptr		= (int) ADC;

        dac_data_count_max	= MCD->epoch_len;
        adc_data_count_max	= MCD->epoch_len;
	dac_data_count		= 0;
	adc_data_count		= 0;


	if (MCD->cmnd==MCMND_ADC_TO_DAC)
	  {                       /* settings for ADC->DAC scanning */
	    dac_data_start_ptr		= (int) ADC;
            dac_get_ptr			= (int) ADC;

	    adc_cyclic_scan_flag	= ML_ON;
	    adc_scan_flag		= ML_ON;
	  }
	else
	  {
	    dac_data_start_ptr	= (int) DAC;
            dac_get_ptr		= (int) DAC;

	    adc_cyclic_scan_flag	= ML_OFF;
	    adc_scan_flag		= ML_OFF;
	  }

	dac_cyclic_scan_flag	= ML_ON;
	dac_scan_flag		= ML_ON;


			/* wait for MCD->status==GO or ABORT*/
	while((MCD->status!=MSTAT_GO) && (MCD->status!=MSTAT_ABORT));

	if ( MCD->status==MSTAT_GO )
	  {
        	adc_scan_flag	= ML_ON;	/* enable saving ADC -data */
		while(adc_scan_flag!=ML_OFF);	/* wait until ADC scanning will OFF */
	  }
	dac_scan_flag	= ML_OFF;	/* disable DAC transmission */
	adc_scan_flag	= ML_OFF;

	return(MERR_OK);
  }
